Make a Palindrome by Inserting Characters - Google Top Interview Questions


Problem Statement :


Given a string s, return the minimum number of characters needed to be inserted so that the string becomes a palindrome.

Constraints

n ≤ 1,000 where n is the length of s

Example 1

Input

s = "radr"

Output

1

Explanation

We can insert "a" to get "radar"



Solution :



title-img




                        Solution in C++ :

int solve(string s) {
    int n = s.length();
    int dp[n + 1][n + 1];
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            if (i == 0) {
                dp[i][j] = j;
            } else if (j == 0) {
                dp[i][j] = i;
            } else if (s[i - 1] == s[n - j]) {
                dp[i][j] = dp[i - 1][j - 1];
            } else {
                dp[i][j] = 1 + min(dp[i][j - 1], dp[i - 1][j]);
            }
        }
    }
    return dp[n][n] / 2;
}
                    


                        Solution in Java :

import java.util.*;

class Solution {
    public int solve(String s) {
        return s.length() - lps(s);
    }

    int lps(String st) {
        char[] s = st.toCharArray();
        int m = s.length;
        int[][] dp = new int[m][m];

        for (int i = 0; i < m; i++) dp[i][i] = 1;

        for (int i = m - 1; i >= 0; i--) {
            for (int j = i + 1; j < m; j++) {
                if (s[i] == s[j]) {
                    dp[i][j] = dp[i + 1][j - 1] + 2;
                } else {
                    dp[i][j] = Math.max(dp[i + 1][j], dp[i][j - 1]);
                }
            }
        }

        return dp[0][m - 1];
    }
}
                    


                        Solution in Python : 
                            
class Solution:
    def solve(self, s):

        """
        #1: Most popular approach: time and space complexity: O(n^2).

        Let f[i][j] be the length of the longest palindromic subsequence in s[i:j+1]
        f[i][j] = f[i+1][j-1] + 2 if s[i] == s[j]
                = max(f[i+1][j], f[i][j-1]) otherwise
        """

        n = len(s)
        f = [[0] * n for _ in range(n)]
        for size in range(1, n + 1):
            for i in range(n - size + 1):
                j = i + size - 1
                if s[i] == s[j]:
                    if i + 1 > j - 1:
                        f[i][j] = size
                    else:
                        f[i][j] = f[i + 1][j - 1] + 2
                else:
                    f[i][j] = max(f[i + 1][j], f[i][j - 1])

        return n - f[0][n - 1]

        """
        #2: A different transition function: time and space complexity: still O(n^2).
        But this is a pathway to a better solution.

        Let f[size][i] be the length of the longest palindromic subsequence in s[i:i+size]
        f[size][i] = f[size-2][i+1] + 2 if s[i] == s[i+size-1]
                = max(f[size-1][i+1], f[size-1][i]) otherwise
        """
        n = len(s)
        f = [[0] * n for _ in range(n + 1)]

        for size in range(1, n + 1):
            for i in range(n - size + 1):
                j = i + size - 1
                if s[i] == s[j]:
                    if size - 2 > 0:
                        f[size][i] = f[size - 2][i + 1] + 2
                    else:
                        f[size][i] = size
                else:
                    f[size][i] = max(f[size - 1][i + 1], f[size - 1][i])

        return n - f[n][0]

        """
        #3: Based on #2, do rolling array to reduce space: time complexity: still O(n^2), space: O(n).

        In #2, notice that f[size] only depends on f[size-1] and f[size-2], so instead of storing the whole
        (n+1) arrays, we just need 3 arrays, f0, f1, f2. f0 is the current f[size], f1 is the f[size-1], and
        f2 is the f[size-2].
        """
        n = len(s)
        f0 = [0] * n
        f1 = [0] * n
        f2 = [0] * n

        for size in range(1, n + 1):
            f0, f1, f2 = [0] * n, f0, f1
            for i in range(n - size + 1):
                j = i + size - 1
                if s[i] == s[j]:
                    if size - 2 > 0:
                        f0[i] = f2[i + 1] + 2
                    else:
                        f0[i] = size
                else:
                    f0[i] = max(f1[i + 1], f1[i])

        return n - f0[0]
                    


View More Similar Problems

Find the Running Median

The median of a set of integers is the midpoint value of the data set for which an equal number of integers are less than and greater than the value. To find the median, you must first sort your set of integers in non-decreasing order, then: If your set contains an odd number of elements, the median is the middle element of the sorted sample. In the sorted set { 1, 2, 3 } , 2 is the median.

View Solution →

Minimum Average Waiting Time

Tieu owns a pizza restaurant and he manages it in his own way. While in a normal restaurant, a customer is served by following the first-come, first-served rule, Tieu simply minimizes the average waiting time of his customers. So he gets to decide who is served first, regardless of how sooner or later a person comes. Different kinds of pizzas take different amounts of time to cook. Also, once h

View Solution →

Merging Communities

People connect with each other in a social network. A connection between Person I and Person J is represented as . When two persons belonging to different communities connect, the net effect is the merger of both communities which I and J belongs to. At the beginning, there are N people representing N communities. Suppose person 1 and 2 connected and later 2 and 3 connected, then ,1 , 2 and 3 w

View Solution →

Components in a graph

There are 2 * N nodes in an undirected graph, and a number of edges connecting some nodes. In each edge, the first value will be between 1 and N, inclusive. The second node will be between N + 1 and , 2 * N inclusive. Given a list of edges, determine the size of the smallest and largest connected components that have or more nodes. A node can have any number of connections. The highest node valu

View Solution →

Kundu and Tree

Kundu is true tree lover. Tree is a connected graph having N vertices and N-1 edges. Today when he got a tree, he colored each edge with one of either red(r) or black(b) color. He is interested in knowing how many triplets(a,b,c) of vertices are there , such that, there is atleast one edge having red color on all the three paths i.e. from vertex a to b, vertex b to c and vertex c to a . Note that

View Solution →

Super Maximum Cost Queries

Victoria has a tree, T , consisting of N nodes numbered from 1 to N. Each edge from node Ui to Vi in tree T has an integer weight, Wi. Let's define the cost, C, of a path from some node X to some other node Y as the maximum weight ( W ) for any edge in the unique path from node X to Y node . Victoria wants your help processing Q queries on tree T, where each query contains 2 integers, L and

View Solution →